;************************************************************
btUp         equ   0x05   ;  
btDown       equ   0x04   ; 
btLeft       equ   0x02   ;
btRight      equ   0x08   ;
;-------------------------------------------------
btSet        equ   0x06   ;
btEsc        equ   0x01   ;
btF1         equ   0x07   ;
btF2         equ   0x03   ;
;//////////////////////////////////////////////////////////////
;**************************************************************
KeyCPU:   ;    
;**************************************************************
        call   Inkey     ;  
        cpi    keyBuf,.255   ;
        jz     Key255        ;  
        incf   keyCount,f    ;
        cpi    keyCount,.3   ;  =
        jz     KeyJob        ;   
        cpi    keyCount,.050 ;  
        jc     KeyOut        ;  
        decf   keyCount,f    ;
KeyJob:
        call   BeeperKey     ;   
        return
Key255:
        clrf  keyCount       ;
KeyOut:
        mvi   keyBuf,.255   ;
        return
;**************************************************************
BeeperKey:     ;   
;**************************************************************
        bsf    Beeper
        call   DelayBeep
        bcf    Beeper
        call   DelayBeep
        bsf    Beeper
        call   DelayBeep
        bcf    Beeper
        call   DelayBeep
        bsf    Beeper
        call   DelayBeep
        bcf    Beeper
        call   DelayBeep
        return
;**************************************************************
DelayBeep:
        mvi      local2,.20
LongBeep:
        mvi      local1,.255
        clrwdt
DelayBeepCuc:
        decfsz   local1,f
        goto     DelayBeepCuc
        decfsz   local2,f
        goto     LongBeep
        return
;**************************************************************
Inkey:
;**************************************************************
        clrf    keyBuf
        clrf    PORTB
        clrwdt
;---------------------------------
        mvi     PORTB,b'01111111'
        incf    keyBuf,f
        btfss   inBtA
        return  ;     
        incf    keyBuf,f
        btfss   inBtB
        return  ;     
;---------------------------------
        mvi     PORTB,b'10111111'
        incf    keyBuf,f
        btfss   inBtA
        return  ;     
        incf    keyBuf,f
        btfss   inBtB
        return  ;     
;---------------------------------
        mvi     PORTB,b'11011111'
        incf    keyBuf,f
        btfss   inBtA
        return  ;     
        incf    keyBuf,f
        btfss   inBtB
        return  ;     
;---------------------------------
        mvi     PORTB,b'11101111'
        incf    keyBuf,f
        btfss   inBtA
        return  ;     
        incf    keyBuf,f
        btfss   inBtB
        return  ;     
;---------------------------------
        mvi     keyBuf,0xff ; no PRESS
        return
;*************************************************************
;/////////////////////////////////////////////////////////////
;*************************************************************
;**************************************************************
;/////////////////////////////////////////////////////////
;**************************************************************
CheckTemp:         ;  
        CALL    startDS1821     ;    1
        CALL    readDS1821      ;   1
        MOVWF   uTempFloor       ;     _
        CALL    stopDS1821      ;    1
        incf    uTempFloor,f     ;
;--------------------------------------------------------------
        btfss   floorOFF        ; 
        goto    FloorJobOff
;--------------------------------------------------------------
        cmp     uTempFloor,uTempDown
        jnc     noDown
        bsf     Rele     ; ON  -   
noDown:
        cmp     uTempFloor,uTempUp
        jc      noUP
FloorJobOff:
        bcf     Rele     ; OFF -    
noUP:
;-------------------------------------------------------------       call     OutDspTemp    ;   
        return                  ;
;**************************************************************
initDS1821:
;*********************************************************
        call    init1wire    ;   DS1821
        MOVLW   0CH          ;  
        MOVWF   mToDS1821
        call    OutByte1wire ;   mToDS1821  DS1821
        MOVLW   03H          ;  ,   1
        MOVWF   mToDS1821
        call    OutByte1wire ;   mToDS1821  DS1821
        MOVLW   .20          ;  20    
        MOVWF   wlocal1
        CALL    DelayMs
        RETURN
;*********************************************************
startDS1821:
;*********************************************************
        call    init1wire    ;   DS1821
        MOVLW   0EEH         ;  
        MOVWF   mToDS1821
        call    OutByte1wire ;   mToDS1821  DS1821
        MOVLW   .1         ; (=100)  100 
        MOVWF   wlocal1
        CALL    DelayMs
        RETURN
;*********************************************************
readDS1821:     ;  
;*********************************************************
        call    init1wire    ;   DS1821
        MOVLW   0AAH         ;  
        MOVWF   mToDS1821
        CALL    OutByte1wire ;   mToDS1821  DS1821
        CALL    InByte1wire  ;    DS1821  W
        MOVF    mFromDS1821, W
        RETURN
;*********************************************************
stopDS1821:    ;  
;*********************************************************
        call    init1wire    ;   DS1821
        MOVLW   22H          ;  
        MOVWF   mToDS1821
        CALL    OutByte1wire ;   mToDS1821  
        RETURN
;*********************************************************
;     1-Wire
;*********************************************************
;/////////////////////////////////////////////////////////
;*********************************************************
init1wire:  ;   DS1821
;*********************************************************
        CALL    PIN_HI  ;       -1- (R=4,7k->+5v)
        CALL    PIN_LO  ;       -0-
        MOVLW   .50     ;  500 
        CALL    DELAY_10USEC
        CALL    PIN_HI  ;       -1- (R=4,7k->+5v)
        MOVLW   .50     ;  500 
        CALL    DELAY_10USEC
        RETURN
;*********************************************************
Wait1wire:      ;  
;*********************************************************
        CALL    InByte1wire    ;    W
        MOVLW   0FFH           ;
        SUBWF   mFromDS1821, W ;
        BTFSS   STATUS, ZR     ;
        GOTO    Wait1wire      ;
        RETURN
;*********************************************************
InByte1wire:    ;    W
;*********************************************************
        MOVLW   .8
        MOVWF   mDelay
        CLRF    mFromDS1821
IN_BYTE_1:
        CALL    PIN_LO  ;       -0-
        NOP
        NOP
        NOP
        NOP
        CALL    PIN_HI ;       -1- (R=4,7k->+5v)
        nop16mhz   ;  28  
        MOVF    PORTC, W        ; 7 usecs later, fetch from NogaDS1821
        MOVWF   wTEMP
        BTFSS   wTEMP, NogDS1821
        BCF     STATUS,CR       ; its a zero
        BTFSC   wTEMP, NogDS1821
        BSF     STATUS, CR       ; its a one
        RRF     mFromDS1821, F
        MOVLW   .6              ; now delay 60 usecs
        CALL    DELAY_10USEC
        DECFSZ  mDelay, F
        GOTO    IN_BYTE_1
        MOVFW   mFromDS1821          ; return the result in W
        RETURN
;*********************************************************
OutByte1wire: ;   mToDS1821  
;*********************************************************
        MOVLW   .8          ; 8  - 
        MOVWF   mDelay
OUT_BYTE_1:
        RRF     mToDS1821, F
        BTFSS   STATUS, CR
        GOTO    OUT_0
        GOTO    OUT_1
OUT_BYTE_2:
        DECFSZ  mDelay, F
        GOTO    OUT_BYTE_1
        RETURN
;-------------------------------------------
OUT_0:
        CALL    PIN_LO  ;       -0-
        MOVLW   .6      ; for 60 usecs
        CALL    DELAY_10USEC
        CALL    PIN_HI ;       -1- (R=4,7k->+5v)
        GOTO    OUT_BYTE_2
OUT_1:
        CALL    PIN_LO ;       -0-
        CALL    PIN_HI ;       -1- (R=4,7k->+5v)
        MOVLW   .6
        CALL    DELAY_10USEC
        GOTO    OUT_BYTE_2
;*********************************************************
PIN_HI:  ;   
;*********************************************************
        BSF     STATUS, RP0
        BSF     TRISC, NogDS1821 ; high impedance
        BCF     STATUS, RP0
        RETURN
;*********************************************************
PIN_LO: ;       -0-
;*********************************************************
        BCF     PORTC, NogDS1821
        BSF     STATUS, RP0
        BCF     TRISC, NogDS1821    ; low impedance zero
        BCF     STATUS, RP0
        RETURN
;*********************************************************
DelayMs:
;*********************************************************
OUTTER:
        MOVLW   .110      ;  1 
        MOVWF   wlocal2
INNER:
        nop16mhz   ;  28  
        DECFSZ  wlocal2, F
        GOTO    INNER
        DECFSZ  wlocal1, F
        GOTO    OUTTER
        RETURN
;*********************************************************
DELAY_10USEC:  ;    W * 10 
;*********************************************************
        MOVWF   wlocal1
DELAY_10USEC_1:
        nop16mhz   ;  28  
        DECFSZ  wlocal1, F
        GOTO    DELAY_10USEC_1
        RETURN
;*************************************************************
;/////////////////////////////////////////////////////////////
;*************************************************************
del_ind  equ  .90        ;   16 
;*************************************************************
write_char:          ;   - 
;*************************************************************
        movwf   PORTB    ; write =  0
        call    busyInd  ; 
        bsf     RS       ; i - 
        goto    write_out
;*************************************************************
write_cmd:           ;  
;*************************************************************
        movwf   PORTB    ; write =  0
        call    busyInd  ; 
        bcf     RS       ; Lo - 
write_out:
        nop
        bcf     RW       ; write 
write_cs:
        call    del_cs   ;  
        bsf     E        ;  Enable
        call    del_cs   ;  
        bcf     E        ;  Enable
;-------------------------------------------------------------
del_cs:                  ;  
       mvi delayTemp,del_ind;
cuc_cs:
      clrwdt
      decf delayTemp,f
      jnz  cuc_cs
      return
;*************************************************************
busyInd:
;*************************************************************
            bsf   RW      ;  
       clrf   local1 ;  1   
            bcf   RS      ; Lo - 
       clrf   local2 ;  2   
        bsf     STATUS,RP0     ; c 1
        mvi     TRISB,0xFF     ; PB0-7=in 
        bcf     STATUS,RP0     ; c 0
busy_cuc:
        decf   local1,f ;  1 = 0
        jz     busy_wait    ;    
        call   write_cs ;  WDT 
        btfss   PORTB,7
        goto    busy_cuc   ;  
        bsf     STATUS,RP0     ; c 1
        clrf    TRISB          ; PB0-7=out 
        bcf     STATUS,RP0     ; c 0
        return     ;  
busy_wait:
        decf   local2,f ;   = 0
        jnz    busy_cuc     ;  
;        mvi     ErrorBait,.02  ; .  BUSY
        return     ;   
;*************************************************************
InitWinstar:
;*************************************************************
           movlw  b'00111000'     ; 8-  
           call   write_cmd       ;  
           movlw  b'00000001'     ;  
           call   write_cmd       ;  
           movlw  b'00000010'     ;  
           call   write_cmd       ;  
           movlw  b'00000110'     ; ,
           call   write_cmd       ;  
           movlw  b'00001100'      ; -,off-
;           movlw  b'00001111'    ; -,on-
           call   write_cmd       ;  
;           retlw  0               ;  
;*************************************************************
DspClearAll:           ;  ec 
;*************************************************************
   call    DspClearUp  ;   
;*************************************************************
DspClearDown:         ;   
;*************************************************************
       movlw   0xC0        ;  
       call    write_cmd   ;  
       mvi     local3,16   ;
ClearInd2:
       movlw   ' '         ;  
       call     write_char ;  
       decfsz   local3,f
       goto     ClearInd2  ;
       return
;*************************************************************
DspClearUp:            ;   
;*************************************************************
       movlw   0x80        ;  
       call    write_cmd   ;  
       mvi     local3,16   ;
ClearInd1:
       movlw   ' '         ;  
       call     write_char ;  
       decfsz   local3,f
       goto     ClearInd1  ;
       return
;*************************************************************
;/////////////////////////////////////////////////////////////
;*************************************************************
hextodec:    ;   hex -> . - 3 
;*************************************************************
        clrf    mDdsLow        ;  
        clrf    mDdsMid        ; 
        clrf    mDdsHigh       ; 
;---------------------------------------------------------
sot_cuc:                       ;  
        incf    mDdsHigh,f     ; 
        movlw   .100           ;
        subwf   mDdsHex,f      ;
        jc     sot_cuc         ;
        decf    mDdsHigh,f     ;
        movlw   .100           ;
        addwf   mDdsHex,f      ;
;---------------------------------------------------------
dec_cuc:                       ;  
        incf    mDdsMid,f      ;
        movlw   .10            ;
        subwf   mDdsHex,f      ;
        jc     dec_cuc         ;
        decf    mDdsMid,f      ;
        movlw   .10            ;
        addwf   mDdsHex,f      ;
;---------------------------------------------------------
ed_cuc:                        ;  
        incf    mDdsLow,f      ;
        movlw   .1             ;
        subwf   mDdsHex,f      ;
        jc     ed_cuc          ;
        decf    mDdsLow,f      ;
        return                 ;
;*************************************************************
;/////////////////////////////////////////////////////////////
;************************************************************
DdsHigh:        ; 3 
;**************************************************
        call     hextodec     ;  Hex -> Des
        movtow   mDdsHigh         ; 
        call     hex              ;   TXT 
        call     write_char   ;  
        goto     dds2
;**************************************************
DdsMidl:        ; 2 
;**************************************************
        call     hextodec     ;  Hex -> Des
dds2:
        movtow   mDdsMid           ; 
        call     hex              ;   TXT 
        call     write_char   ;  
DdsLow:         ; 1 
        movtow   mDdsLow          ; 
        call     hex              ;   TXT 
        call     write_char   ;  
        retlw    0                ;  
;**************************************************
;//////////////////////////////////////////////////
;**************************************************
OutDspTemp:    ;   
;**************************************************
       movlw   0x88          ;   
       call    write_cmd ;  
       movlw   'F'
       call   write_char  ;  
       movlw   'L'
       call   write_char  ;  
       movlw   'O'
       call   write_char  ;  
       movlw   'O'
       call   write_char  ;  
       movlw   'R'
       call   write_char  ;  
       movlw   '+'
       call   write_char  ;  
       mov     mDdsHex,uTempFloor
       call   DdsMidl     ; 2 
;--------------------------------------------------
;--------------------------------------------------
       movlw   0xC9       ;   
       call    write_cmd  ;  
       btfsc   floorOFF        ; 
       goto    FloorJob
;--------------------------------------------------
       movlw   ' '
       call   write_char  ;  
       movlw   'O'
       call   write_char  ;  
       movlw   'F'
       call   write_char  ;  
       movlw   'F'
       call   write_char  ;  
       movlw   ' '
       call   write_char  ;  
       movlw   ' '
       call   write_char  ;  
       movlw   ' '
       call   write_char  ;  
       return
;--------------------------------------------------
FloorJob:
       btfss   Rele       ; ON  -   
       goto    NoZnak
UstZnak:
       movlw   '+'
       call   write_char  ;  
       goto   OutZnak
NoZnak:
       movlw   '-'
       call   write_char  ;  
       goto   OutZnak
OutZnak:
       movlw   'S'
       call   write_char  ;  
       movlw   'E'
       call   write_char  ;  
       movlw   'T'
       call   write_char  ;  
       movlw   '+'
       call   write_char  ;  
       mov    mDdsHex,uTempDown
       incf   mDdsHex,f
       call   DdsMidl     ; 2 
       return
;//////////////////////////////////////////////////
;**************************************************







